diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/test_foreign_key_sql.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/test_foreign_key_sql.py
new file mode 100644
index 000000000..8d3fb67b5
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/test_foreign_key_sql.py
@@ -0,0 +1,102 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
+    import utils as tables_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from . import utils as fk_utils
+
+
+class ForeignKeyGetSqlTestCase(BaseTestGenerator):
+    """This class will fetch foreign key sql from existing table"""
+    url = '/browser/foreign_key/sql/'
+
+    # Generates scenarios
+    scenarios = utils.generate_scenarios("foreign_key_sql",
+                                         fk_utils.test_cases)
+
+    def setUp(self):
+        # Load test data
+        self.data = self.test_data
+
+        # Create db connection
+        self.db_name = parent_node_dict["database"][-1]["db_name"]
+        schema_info = parent_node_dict["schema"][-1]
+        self.server_id = schema_info["server_id"]
+        self.db_id = schema_info["db_id"]
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.server_id, self.db_id)
+        if not db_con['data']["connected"]:
+            raise Exception(
+                "Could not connect to database to fetch a foreign "
+                "key constraint.")
+
+        # Create schema
+        self.schema_id = schema_info["schema_id"]
+        self.schema_name = schema_info["schema_name"]
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to fetch a foreign "
+                            "key constraint.")
+
+        # Create local table
+        self.local_table_name = "local_table_foreignkey_get_%s" % \
+                                (str(uuid.uuid4())[1:8])
+        self.local_table_id = tables_utils.create_table(
+            self.server, self.db_name, self.schema_name, self.local_table_name)
+
+        # Create foreign table
+        self.foreign_table_name = "foreign_table_foreignkey_get_%s" % \
+                                  (str(uuid.uuid4())[1:8])
+        self.foreign_table_id = tables_utils.create_table(
+            self.server, self.db_name, self.schema_name,
+            self.foreign_table_name)
+
+        # Create foreign key
+        self.foreign_key_name = "test_foreignkey_get_%s" % \
+                                (str(uuid.uuid4())[1:8])
+        self.foreign_key_id = fk_utils.create_foreignkey(
+            self.server, self.db_name, self.schema_name, self.local_table_name,
+            self.foreign_table_name)
+
+    def runTest(self):
+        """This function will delete foreign key sql attached to table
+        column. """
+        if self.is_positive_test:
+            response = fk_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = fk_utils.api_get(self)
+            elif 'foreign_key_id' in self.data:
+                self.foreign_key_id = self.data["foreign_key_id"]
+                response = fk_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        # Disconnect the database
+        database_utils.disconnect_database(self, self.server_id, self.db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/test_foreign_key_validate.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/test_foreign_key_validate.py
new file mode 100644
index 000000000..f8dc9475c
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/test_foreign_key_validate.py
@@ -0,0 +1,97 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
+    import utils as tables_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from . import utils as fk_utils
+
+
+class ForeignKeyValidateTestCase(BaseTestGenerator):
+    url = '/browser/foreign_key/validate/'
+
+    # Generates scenarios from cast_test_data.json file
+    scenarios = utils.generate_scenarios("foreign_constraint_validate",
+                                         fk_utils.test_cases)
+
+    def setUp(self):
+        # Load test data
+        self.data = self.test_data
+
+        # Create db connection
+        self.db_name = parent_node_dict["database"][-1]["db_name"]
+        schema_info = parent_node_dict["schema"][-1]
+        self.server_id = schema_info["server_id"]
+        self.db_id = schema_info["db_id"]
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.server_id, self.db_id)
+        if not db_con['data']["connected"]:
+            raise Exception(
+                "Could not connect to database to fetch a foreign "
+                "key constraint.")
+
+        # Create schema
+        self.schema_id = schema_info["schema_id"]
+        self.schema_name = schema_info["schema_name"]
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to fetch a foreign "
+                            "key constraint.")
+
+        # Create local table
+        self.local_table_name = "local_table_foreignkey_get_%s" % \
+                                (str(uuid.uuid4())[1:8])
+        self.local_table_id = tables_utils.create_table(
+            self.server, self.db_name, self.schema_name, self.local_table_name)
+
+        # Create foreign table
+        self.foreign_table_name = "foreign_table_foreignkey_get_%s" % \
+                                  (str(uuid.uuid4())[1:8])
+        self.foreign_table_id = tables_utils.create_table(
+            self.server, self.db_name, self.schema_name,
+            self.foreign_table_name)
+
+        # Create foreign key
+        self.foreign_key_name = "test_foreignkey_get_%s" % \
+                                (str(uuid.uuid4())[1:8])
+        self.foreign_key_id = fk_utils.create_foreignkey(
+            self.server, self.db_name, self.schema_name, self.local_table_name,
+            self.foreign_table_name)
+
+    def runTest(self):
+        """This function will validate check constraint to table."""
+        if self.is_positive_test:
+            response = fk_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = fk_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        # Disconnect the database
+        database_utils.disconnect_database(self, self.server_id, self.db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/utils.py
index 80d810232..ea77473f2 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/tests/utils.py
@@ -9,13 +9,93 @@
 
 
 import sys
+import os
+import json
 import traceback
+from urllib.parse import urlencode
 
 from regression.python_test_utils import test_utils as utils
 
+# Load test data from json file.
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+with open(CURRENT_PATH + "/foreign_key_test_data.json") as data_file:
+    test_cases = json.load(data_file)
+
+
+# api call method
+def api_create(self):
+    return self.tester.post("{0}{1}/{2}/{3}/{4}/{5}/".
+                            format(self.url, utils.SERVER_GROUP,
+                                   self.server_id, self.db_id,
+                                   self.schema_id, self.local_table_id),
+                            data=json.dumps(self.data),
+                            content_type='html/json'
+                            )
+
+
+def api_delete(self, foreign_key_id=None):
+    if foreign_key_id is None:
+        foreign_key_id = self.foreign_key_id
+    return self.tester.delete("{0}{1}/{2}/{3}/{4}/{5}/{6}".
+                              format(self.url, utils.SERVER_GROUP,
+                                     self.server_id, self.db_id,
+                                     self.schema_id,
+                                     self.local_table_id,
+                                     foreign_key_id),
+                              data=json.dumps(self.data),
+                              follow_redirects=True
+                              )
+
+
+def api_get(self, foreign_key_id=None):
+    if foreign_key_id is None:
+        foreign_key_id = self.foreign_key_id
+    return self.tester.get("{0}{1}/{2}/{3}/{4}/{5}/{6}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.db_id,
+                                  self.schema_id,
+                                  self.local_table_id,
+                                  foreign_key_id),
+                           data=json.dumps(self.data),
+                           follow_redirects=True
+                           )
+
+
+def api_get_msql(self, url_encode_data):
+    return self.tester.get("{0}{1}/{2}/{3}/{4}/{5}/{6}?{7}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.db_id,
+                                  self.schema_id, self.local_table_id,
+                                  self.foreign_key_id,
+                                  urlencode(url_encode_data)),
+                           follow_redirects=True
+                           )
+
+
+def api_put(self):
+    return self.tester.put("{0}{1}/{2}/{3}/{4}/{5}/{6}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.db_id,
+                                  self.schema_id,
+                                  self.local_table_id,
+                                  self.foreign_key_id),
+                           data=json.dumps(self.data),
+                           follow_redirects=True
+                           )
+
+
+def api_get_converging_index(self, req_args):
+    return self.tester.get("{0}{1}/{2}/{3}/{4}/{5}/{6}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.db_id,
+                                  self.schema_id, self.local_table_id,
+                                  req_args),
+                           follow_redirects=True
+                           )
+
 
 def create_foreignkey(server, db_name, schema_name, local_table_name,
-                      foreign_table_name):
+                      foreign_table_name, query_val=None):
     """
     This function creates a column under provided table.
     :param server: server details
@@ -31,6 +111,13 @@ def create_foreignkey(server, db_name, schema_name, local_table_name,
     :return table_id: table id
     :rtype: int
     """
+    if query_val is None:
+        query = "ALTER TABLE %s.%s ADD FOREIGN KEY (id) REFERENCES %s.%s " \
+                "(id) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION" % \
+                (schema_name, local_table_name, schema_name,
+                 foreign_table_name)
+    else:
+        query = eval(query_val)
     try:
         connection = utils.get_db_connection(db_name,
                                              server['username'],
@@ -41,11 +128,7 @@ def create_foreignkey(server, db_name, schema_name, local_table_name,
         old_isolation_level = connection.isolation_level
         connection.set_isolation_level(0)
         pg_cursor = connection.cursor()
-        query = "ALTER TABLE %s.%s ADD FOREIGN KEY (id) REFERENCES %s.%s " \
-                "(id) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION" % \
-                (
-                    schema_name, local_table_name, schema_name,
-                    foreign_table_name)
+
         pg_cursor.execute(query)
         connection.set_isolation_level(old_isolation_level)
         connection.commit()
@@ -61,7 +144,7 @@ def create_foreignkey(server, db_name, schema_name, local_table_name,
         traceback.print_exc(file=sys.stderr)
 
 
-def verify_foreignkey(server, db_name, local_table_name):
+def verify_foreignkey(server, db_name, local_table_name, fk_name=None):
     """
     This function verifies foreign key constraint exist or not.
     :param server: server details
@@ -73,6 +156,10 @@ def verify_foreignkey(server, db_name, local_table_name):
     :return table: table record from database
     :rtype: tuple
     """
+    if fk_name is None:
+        conname = local_table_name + '_id_fkey'
+    else:
+        conname = fk_name
     try:
         connection = utils.get_db_connection(db_name,
                                              server['username'],
@@ -82,8 +169,7 @@ def verify_foreignkey(server, db_name, local_table_name):
                                              server['sslmode'])
         pg_cursor = connection.cursor()
         pg_cursor.execute(
-            "SELECT oid FROM pg_constraint where conname='%s_id_fkey'" %
-            local_table_name)
+            "SELECT oid FROM pg_constraint where conname='%s'" % conname)
         fk_record = pg_cursor.fetchone()
         connection.close()
         return fk_record
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/tests/test_index_constraint_add.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/tests/test_index_constraint_add.py
index 88526ca4b..ab1fd8cd9 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/tests/test_index_constraint_add.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/tests/test_index_constraint_add.py
@@ -9,6 +9,7 @@
 
 import json
 import uuid
+from unittest.mock import patch
 
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
@@ -26,25 +27,16 @@ class IndexConstraintAddTestCase(BaseTestGenerator):
     """This class will add index constraint(primary key or unique key) to
     table column"""
     skip_on_database = ['gpdb']
-    primary_key_name = "test_primarykey_add_%s" % \
-                       (str(uuid.uuid4())[1:8])
-    primary_key_data = {"name": primary_key_name,
-                        "spcname": "pg_default",
-                        "columns": [{"column": "id"}]
-                        }
-    unique_key_name = "test_uniquekey_add_%s" % \
-                      (str(uuid.uuid4())[1:8])
-    unique_key_data = {"name": unique_key_name,
-                       "spcname": "pg_default",
-                       "columns": [{"column": "id"}]}
-    scenarios = [
-        ('Add primary Key constraint to table',
-         dict(url='/browser/primary_key/obj/', data=primary_key_data)),
-        ('Add unique Key constraint to table',
-         dict(url='/browser/unique_constraint/obj/', data=unique_key_data))
-    ]
+
+    # Generates scenarios
+    scenarios = utils.generate_scenarios("index_constraint_create",
+                                         index_constraint_utils.test_cases)
 
     def setUp(self):
+        # Load test data
+        self.data = self.test_data
+
+        # Create db connection
         self.db_name = parent_node_dict["database"][-1]["db_name"]
         schema_info = parent_node_dict["schema"][-1]
         self.server_id = schema_info["server_id"]
@@ -54,6 +46,8 @@ class IndexConstraintAddTestCase(BaseTestGenerator):
         if not db_con['data']["connected"]:
             raise Exception("Could not connect to database to add a "
                             "index constraint(primary key or unique key).")
+
+        # Create schema
         self.schema_id = schema_info["schema_id"]
         self.schema_name = schema_info["schema_name"]
         schema_response = schema_utils.verify_schemas(self.server,
@@ -62,6 +56,8 @@ class IndexConstraintAddTestCase(BaseTestGenerator):
         if not schema_response:
             raise Exception("Could not find the schema to add a index "
                             "constraint(primary key or unique key).")
+
+        # Create table
         self.table_name = "table_indexconstraint_%s" % \
                           (str(uuid.uuid4())[1:8])
         self.table_id = tables_utils.create_table(self.server,
@@ -72,87 +68,56 @@ class IndexConstraintAddTestCase(BaseTestGenerator):
     def runTest(self):
         """This function will add index constraint(primary key or unique key)
         to table column."""
-        response = self.tester.post(
-            self.url + str(utils.SERVER_GROUP) + '/' +
-            str(self.server_id) + '/' + str(self.db_id) +
-            '/' + str(self.schema_id) + '/' + str(self.table_id) + '/',
-            data=json.dumps(self.data),
-            content_type='html/json')
-        self.assertEquals(response.status_code, 200)
-
-    def tearDown(self):
-        # Disconnect the database
-        database_utils.disconnect_database(self, self.server_id, self.db_id)
-
+        # Create using index
+        if "index" in self.data:
+            index_name = self.data["index"] + (str(uuid.uuid4())[1:8])
+            self.data["index"] = index_name
 
-class ConstraintsUsingIndexAddTestCase(BaseTestGenerator):
-    """This class will add the constraint(primary key or unique key) to the
-    table column using newly created index"""
-    skip_on_database = ['gpdb']
-
-    primary_key_name = "test_primarykey_add_%s" % (str(uuid.uuid4())[1:8])
-    primary_index_name = "test_primaryindex_add_%s" % (str(uuid.uuid4())[1:8])
-    primary_key_data = {
-        "name": primary_key_name,
-        "spcname": "pg_default",
-        "columns": [],
-        "index": primary_index_name
-    }
-
-    unique_key_name = "test_uniquekey_add_%s" % (str(uuid.uuid4())[1:8])
-    unique_index_name = "test_uniqueindex_add_%s" % (str(uuid.uuid4())[1:8])
-    unique_key_data = {
-        "name": unique_key_name,
-        "spcname": "pg_default",
-        "columns": [],
-        "index": unique_index_name
-    }
-
-    scenarios = [
-        ('Add primary Key constraint to table using index',
-         dict(url='/browser/primary_key/obj/', data=primary_key_data)),
-        ('Add unique Key constraint to table using index',
-         dict(url='/browser/unique_constraint/obj/', data=unique_key_data))
-    ]
-
-    def setUp(self):
-        self.db_name = parent_node_dict["database"][-1]["db_name"]
-        schema_info = parent_node_dict["schema"][-1]
-        self.server_id = schema_info["server_id"]
-        self.db_id = schema_info["db_id"]
-        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
-                                                 self.server_id, self.db_id)
-        if not db_con['data']["connected"]:
-            raise Exception("Could not connect to database to add a "
-                            "constraint using index.")
-        self.schema_id = schema_info["schema_id"]
-        self.schema_name = schema_info["schema_name"]
-        schema_response = schema_utils.verify_schemas(self.server,
-                                                      self.db_name,
-                                                      self.schema_name)
-        if not schema_response:
-            raise Exception("Could not find the schema to add a index "
-                            "constraint(primary key or unique key).")
-        self.table_name = "table_constraint_%s" % (str(uuid.uuid4())[1:8])
-        self.table_id = tables_utils.create_table(self.server, self.db_name,
-                                                  self.schema_name,
-                                                  self.table_name)
-
-    def runTest(self):
-        """This function will add index constraint(primary key or unique key)
-        to table column."""
-        self.index_id = \
-            index_constraint_utils.create_unique_index(
+            self.index_id = index_constraint_utils.create_unique_index(
                 self.server, self.db_name, self.schema_name, self.table_name,
-                self.data["index"], "name")
-
-        response = self.tester.post(
-            self.url + str(utils.SERVER_GROUP) + '/' +
-            str(self.server_id) + '/' + str(self.db_id) +
-            '/' + str(self.schema_id) + '/' + str(self.table_id) + '/',
-            data=json.dumps(self.data),
-            content_type='html/json')
-        self.assertEquals(response.status_code, 200)
+                index_name, "name")
+
+        # Constraint name
+        if "constraint_name" in self.data:
+            constraint_name = self.data["constraint_name"] + (
+                str(uuid.uuid4())[1:8])
+            self.data["name"] = constraint_name
+        else:
+            if "index" in self.data:
+                if "primary_key" in self.url:
+                    constraint_name = index_name
+                else:
+                    constraint_name = self.table_name + '_id_key'
+            else:
+                if "primary_key" in self.url:
+                    constraint_name = self.table_name + '_pkey'
+                elif "columns" in self.data:
+                    constraint_name = self.table_name + '_' + \
+                        self.data["columns"][0]["column"] + '_key'
+
+        if self.is_positive_test:
+            response = index_constraint_utils.api_create(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+
+            # Verify in backend
+            self.assertIsNotNone(index_constraint_utils.
+                                 verify_index_constraint(self.server,
+                                                         self.db_name,
+                                                         constraint_name),
+                                 "Could not find constraint created.")
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=eval(self.mock_data["return_value"])):
+                    response = index_constraint_utils.api_create(self)
+            else:
+                response = index_constraint_utils.api_create(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
 
     def tearDown(self):
         # Disconnect the database
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/tests/test_index_constraint_delete.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/tests/test_index_constraint_delete.py
index f35a00b4a..d3ae82f07 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/tests/test_index_constraint_delete.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/tests/test_index_constraint_delete.py
@@ -8,6 +8,7 @@
 ##########################################################################
 
 import uuid
+from unittest.mock import patch
 
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
@@ -25,20 +26,16 @@ class IndexConstraintDeleteTestCase(BaseTestGenerator):
     """This class will delete index constraint(primary key or unique key) of
     table column"""
     skip_on_database = ['gpdb']
-    primary_key_name = "test_primarykey_delete_%s" % \
-                       (str(uuid.uuid4())[1:8])
-    unique_key_name = "test_uniquekey_delete_%s" % \
-                      (str(uuid.uuid4())[1:8])
-    scenarios = [
-        ('Delete primary Key constraint of table',
-         dict(url='/browser/primary_key/obj/', name=primary_key_name,
-              type="PRIMARY KEY")),
-        ('Delete unique Key constraint of table',
-         dict(url='/browser/unique_constraint/obj/', name=unique_key_name,
-              type="UNIQUE"))
-    ]
+
+    # Generates scenarios
+    scenarios = utils.generate_scenarios("index_constraint_delete",
+                                         index_constraint_utils.test_cases)
 
     def setUp(self):
+        # Load test data
+        self.data = self.test_data
+
+        # Create db connection
         self.db_name = parent_node_dict["database"][-1]["db_name"]
         schema_info = parent_node_dict["schema"][-1]
         self.server_id = schema_info["server_id"]
@@ -48,6 +45,8 @@ class IndexConstraintDeleteTestCase(BaseTestGenerator):
         if not db_con['data']["connected"]:
             raise Exception("Could not connect to database to add a "
                             "index constraint(primary key or unique key).")
+
+        # Create schema
         self.schema_id = schema_info["schema_id"]
         self.schema_name = schema_info["schema_name"]
         schema_response = schema_utils.verify_schemas(self.server,
@@ -56,29 +55,47 @@ class IndexConstraintDeleteTestCase(BaseTestGenerator):
         if not schema_response:
             raise Exception("Could not find the schema to add a index "
                             "constraint(primary key or unique key).")
+
+        # Create table
         self.table_name = "table_indexconstraint_%s" % \
                           (str(uuid.uuid4())[1:8])
         self.table_id = tables_utils.create_table(self.server,
                                                   self.db_name,
                                                   self.schema_name,
                                                   self.table_name)
+        # Create constraint
+        self.constraint_name = self.data["constraint_name"] + \
+            (str(uuid.uuid4())[1:8])
+        self.type = self.data["type"]
+        self.index_constraint_id = index_constraint_utils. \
+            create_index_constraint(self.server, self.db_name,
+                                    self.schema_name, self.table_name,
+                                    self.constraint_name, self.type)
 
     def runTest(self):
         """This function will delete index constraint(primary key or
         unique key) of table column."""
-        index_constraint_id = \
-            index_constraint_utils.create_index_constraint(
-                self.server, self.db_name, self.schema_name, self.table_name,
-                self.name, self.type)
-        response = self.tester.delete(
-            "{0}{1}/{2}/{3}/{4}/{5}/{6}".format(self.url, utils.SERVER_GROUP,
-                                                self.server_id, self.db_id,
-                                                self.schema_id,
-                                                self.table_id,
-                                                index_constraint_id),
-            follow_redirects=True
-        )
-        self.assertEquals(response.status_code, 200)
+        if self.is_positive_test:
+            if self.is_list:
+                self.data['ids'] = [self.index_constraint_id]
+                response = index_constraint_utils.api_delete(self, '')
+            else:
+                response = index_constraint_utils.api_delete(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = index_constraint_utils.api_delete(self)
+            elif 'index_constraint_id' in self.data:
+                self.index_constraint_id = self.data["index_constraint_id"]
+                response = index_constraint_utils.api_delete(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
 
     def tearDown(self):
         # Disconnect the database
